public without sharing class ChatbotDemoCaseCreation {
// Add this class to the Permission set: sfdc.chatbot.service.permset
// without sharing is used so we can associate the LiveChatTranscript
// with the Case, since this is just a demo.  Let's be more secure in
// production.  Likewise, we really should safety check the user input.

	// Values from the chat bot    
    public class ChatBotCaseInput {
        @InvocableVariable(required=true)
        public String email;
        @InvocableVariable(required=true)
        public String name;
        @InvocableVariable(required=true)
        public String subject;        
        @InvocableVariable(required=true)
        public Id chattranscript;
    }
    
    // Values to return to the chat bot
    public class ChatBotCaseOutput {
        @InvocableVariable(required=true)
        public String caseNumber;
    }    

    // We're using a special record type for cases
    // created through the chat bot.  That's optional.
    // We should use a good label and description here.
    @InvocableMethod(label='Demo - Create a case' description='Create a case from the chatbot')
    public static List<ChatBotCaseOutput> makeaCase(List<ChatBotCaseInput> inputs) {

        Id ChatbotRecordTypeId = Schema.SObjectType.Case.getRecordTypeInfosByDeveloperName().get('Chatbot').getRecordTypeId();
        List<ChatBotCaseOutput> caseresults = new List<ChatBotCaseOutput>();

        for(ChatBotCaseInput i:inputs)
        {
            ChatBotCaseOutput newcaseid = new ChatBotCaseOutput();
            // Create the case
            Case chatcase = new Case();
            chatcase.SuppliedEmail = i.email;
            chatcase.SuppliedName = i.name;
            chatcase.subject = i.subject;
            chatcase.RecordTypeId = ChatbotRecordTypeId;
            chatcase.Status = 'New';
        	insert chatcase;
            
            // Find the case number, which is not the same as case id
            List<Case> Createdcase = [SELECT casenumber FROM Case WHERE id =:chatcase.id];
            newcaseid.caseNumber = Createdcase[0].CaseNumber;
			caseresults.add(newcaseid); 
            
            // Associate chat bot transcript with the case
            List<LiveChatTranscript> transcripts = [SELECT id, CaseId FROM LiveChatTranscript WHERE Id = :i.chattranscript LIMIT 1];
            for(LiveChatTranscript j : transcripts)
            {
                j.CaseId = chatcase.id;
            }
            update transcripts;
        }
                
		return caseresults;
    }
}